#include "aimtrans.h"

int at_auth_user(ati ti, jpacket jp)
{
	char *name;
	char *pass;
    xmlnode res;
	at_session s;
    xmlnode x;
	
    x = at_xdb_get(ti, jp->from, AT_NS_AUTH);
    

    if(x == NULL)
    { /* no data for this user */
	    res = (xmlnode)jid_xres(jp->to);

    	name = xmlnode_get_attrib(res, "name");
	    pass = xmlnode_get_attrib(res, "pass");

    	log_debug(ZONE, "[AIM] Auth recevied for %s\n", xmlnode2str(res));

        if(name == NULL || pass == NULL)
        {
            xmlnode err, m;
            
            m = xmlnode_new_tag("message");

            xmlnode_put_attrib(m, "type", "error");
            xmlnode_put_attrib(m, "from", jid_full(jp->to));
            xmlnode_put_attrib(m, "to", jid_full(jp->from));

            err = xmlnode_insert_tag(m, "error");
            xmlnode_put_attrib(err, "code", "407");
            xmlnode_insert_cdata(err, "No Logon Data Found", -1);

            deliver(dpacket_new(m), ti->i);
            xmlnode_free(jp->x);

            return 1;
        } else {
            xmlnode message, body, subject;
            xmlnode aimdata;
            int ret;

            /* set XDB */
            aimdata = xmlnode_new_tag("logon");
            xmlnode_put_attrib(aimdata, "id", name);
            xmlnode_put_attrib(aimdata, "pass", pass);

            ret = at_xdb_set(ti, jp->to->server, jp->from, aimdata, AT_NS_AUTH);
            if(ret == 1)
                xmlnode_free(aimdata);

            /* notify user of the security hole */
            message = xmlnode_new_tag("message");
            body    = xmlnode_insert_tag(message, "body");
            subject = xmlnode_insert_tag(message, "subject");
    
            xmlnode_put_attrib(message, "to", jid_full(jp->from));
            xmlnode_put_attrib(message, "from", jid_full(jp->to));

            xmlnode_insert_cdata(subject, "SECURITY NOTICE", -1);
            xmlnode_insert_cdata(body, "AIM Transport Security Notice:  You were logged in using a relatively insecure method, Your AIM Password is being stored in Plain Text in your roster.  If you would like your password to be stored using a more secure method, please un-register with the AIM Transport, and re-register, so that AIM Transport can safely store your password on the Server.\n\nNOTE: You will not receive this message again.", -1);

            deliver(dpacket_new(message), ti->i);
            
            x = xmlnode_dup(res);
        }
    }

    log_debug(ZONE,"[AT] logging in session");
    at_session_create(ti, x, jp);

    xmlnode_free(x);
    xmlnode_free(jp->x);

    return 1;

}

void at_auth_subscribe(ati ti, jpacket jp)
{
    /* Here we actually subscribe to the user */
    xmlnode x;
    jid jnew;

    x = xmlnode_new_tag("presence");

    jnew = jid_new(xmlnode_pool(x), ti->i->id);
    jid_set(jnew, "registered", JID_RESOURCE);
    
    log_debug(ZONE, "[AIM] Subscribing to %s presence\n", jid_full(jp->from));
	
    xmlnode_put_attrib(x, "to", jid_full(jp->from));
    xmlnode_put_attrib(x, "from", jid_full(jnew));
    xmlnode_put_attrib(x, "type", "subscribe");

    deliver(dpacket_new(x), ti->i);

    return;
}
